__TEST_AND_CLEAR_BIT(9)

NAME
__test_and_clear_bit - Clear a bit and return its old value

SYNOPSIS

int __test_and_clear_bit(long nr, volatile unsigned long * addr);

ARGUMENTS

nr
    Bit to clear

addr
    Address to count from

DESCRIPTION

This operation is non-atomic and can be reordered. If two examples of this operation race, one can appear to succeed but actually fail. You must protect multiple accesses with a lock.

NOTE

the operation is performed atomically with respect to the local CPU, but not other CPUs. Portable code should not rely on this behaviour. KVM relies on this behaviour on x86 for modifying memory that is also

ACCESSED FROM A HYPERVISOR ON THE SAME CPU IF RUNNING IN A VM

don't change this without also updating arch/x86/kernel/kvm.c

COPYRIGHT